unit UnitI2C;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, UnitMain, UnitSG4, UnitErrorCode;

type
  TfmI2C = class(TForm)
    Panel1: TPanel;
    Label4: TLabel;
    ed_data: TEdit;
    btn_writei2c: TButton;
    ed_slv: TEdit;
    btn_readi2c: TButton;
    ed_cnt: TEdit;
    UpDown2: TUpDown;
    btn_setscl: TButton;
    cb_clk: TComboBox;
    Memo1: TMemo;
    btn_memclear: TButton;
    StatusBar1: TStatusBar;
    procedure btn_writei2cClick(Sender: TObject);
    procedure btn_readi2cClick(Sender: TObject);
    procedure btn_setsclClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btn_memclearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure setstatus(stxt : String);
    procedure wlog(stxt : String);
  end;

var
  fmI2C: TfmI2C;

implementation

{$R *.DFM}

procedure TfmI2C.btn_writei2cClick(Sender: TObject);
var slv : byte;
begin
  slv := StrToInt('$'+ed_slv.text);
  setstatus('write i2c:..'+ cx_GetErrorString(cx_writei2c(hcomm,slv,ed_data.text)));
end;

procedure TfmI2C.btn_readi2cClick(Sender: TObject);
var slv, cnt : byte;
    sdata : String;
    dwerr : DWORD;
begin
  slv := StrToInt('$'+ed_slv.text);
  cnt := StrToInt(ed_cnt.text);
  dwerr := cx_readi2c(hcomm,slv,cnt,sdata);
  if dwerr = RET_OK then
    wlog(sdata);
  setstatus('read i2c:..' + cx_GetErrorString(dwerr));
end;

procedure TfmI2C.btn_setsclClick(Sender: TObject);
var clk : byte;
begin
  case cb_clk.itemindex of
  0 : clk := 25;
  1 : clk := 50;
  2 : clk := 100;
  else clk := 100;
  end;
  setstatus('set scl:..'+ cx_GetErrorString(cx_i2cfreq(hcomm,clk)));
end;

procedure TfmI2C.setstatus(stxt: String);
begin
  StatusBar1.Panels[0].Text := stxt;
end;

procedure TfmI2C.wlog(stxt: String);
begin
  memo1.lines.add(stxt);
end;

procedure TfmI2C.FormCreate(Sender: TObject);
begin
  cb_clk.ItemIndex := 2;
end;

procedure TfmI2C.btn_memclearClick(Sender: TObject);
begin
  memo1.Clear;
end;

end.
