unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, UnitComPort, UnitSG4, UnitErrorCode,
  uSG4Converter, uGCodeAnatomizer, upathdll, Buttons, IniFiles, Menus;

type
  TSettings = record
    VelUnit : Byte;
    Vmax   : Integer;
    Vmin   : Integer;
    Accel  : Integer;
    Decel  : Integer;
  end;

  TEngineThread = class(TThread)
  private
    com_handle : THandle;
    cmd_stop : boolean;
    gcode_run : byte;
    TimeTicks  : DWORD;
    cnc_code : String;
    idx_sg4 : integer;
    gcode_lines_count : DWORD;
    last_buffered_line_num : DWORD;
    AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG : Byte;
    AX, AY, AZ, AU : Integer;
    ANUM, AVACT : DWORD;
    function update_params : boolean;
    procedure get_cnc_code;
    function move_next : boolean;
    procedure display_status;
    procedure disableControls;
    function get_runstate(AState: Byte): String;
  public
    procedure Execute; override;
  end;

  Tfmmain = class(TForm)
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    Panel2: TPanel;
    ed_comnr: TEdit;
    BtnComport: TButton;
    lbbaud: TLabel;
    UpDown1: TUpDown;
    cb_baud: TComboBox;
    TabSheet3: TTabSheet;
    od_gcode: TOpenDialog;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel5: TPanel;
    PageControl2: TPageControl;
    TabSheet4: TTabSheet;
    lb_gcode: TListBox;
    TabSheet5: TTabSheet;
    lb_sg4code: TListBox;
    Panel4: TPanel;
    btn_file: TButton;
    Panel8: TPanel;
    GroupBox1: TGroupBox;
    ed_vmax: TEdit;
    Label1: TLabel;
    Label5: TLabel;
    ed_vmin: TEdit;
    Label7: TLabel;
    ed_accel: TEdit;
    Label9: TLabel;
    ed_decel: TEdit;
    Panel6: TPanel;
    Panel9: TPanel;
    Label15: TLabel;
    Label17: TLabel;
    Label21: TLabel;
    lb_runstate: TLabel;
    cb_lx: TCheckBox;
    cb_rx: TCheckBox;
    cb_ly: TCheckBox;
    cb_ry: TCheckBox;
    cb_lz: TCheckBox;
    cb_rz: TCheckBox;
    cb_lu: TCheckBox;
    cb_ru: TCheckBox;
    cb_flx: TCheckBox;
    cb_frx: TCheckBox;
    cb_fry: TCheckBox;
    cb_fly: TCheckBox;
    cb_flz: TCheckBox;
    cb_frz: TCheckBox;
    cb_fru: TCheckBox;
    cb_flu: TCheckBox;
    cb_fifoenabled: TCheckBox;
    cb_error: TCheckBox;
    cb_delay: TCheckBox;
    Panel7: TPanel;
    Label27: TLabel;
    lb_cax: TLabel;
    lb_cay: TLabel;
    Label_17: TLabel;
    lb_caz: TLabel;
    Label31: TLabel;
    lb_cav: TLabel;
    Label38: TLabel;
    Panel10: TPanel;
    btn_xplus: TBitBtn;
    btn_yplus: TBitBtn;
    btn_zplus: TBitBtn;
    btn_xminus: TBitBtn;
    btn_yminus: TBitBtn;
    btn_zminus: TBitBtn;
    cb_step: TComboBox;
    Label2: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    lb_fax: TLabel;
    lb_fay: TLabel;
    lb_faz: TLabel;
    Label20: TLabel;
    Label29: TLabel;
    cb_vunit: TComboBox;
    Label34: TLabel;
    Label32: TLabel;
    ed_vmax_ul: TEdit;
    Label33: TLabel;
    ed_vmin_ul: TEdit;
    Label35: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    ed_vmax_ll: TEdit;
    Label41: TLabel;
    ed_vmin_ll: TEdit;
    Label42: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    ed_vminpervmax: TEdit;
    ed_acceltime: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    btn_submit1: TButton;
    Label4: TLabel;
    ed_unitperstep: TEdit;
    Label3: TLabel;
    cb_unit: TComboBox;
    btn_run: TButton;
    btn_i2c: TButton;
    btn_sg4: TButton;
    btn_showpath: TButton;
    btn_hidepath: TButton;
    Label28: TLabel;
    lb_cnum: TLabel;
    lb_cbufnum: TLabel;
    Label30: TLabel;
    Label36: TLabel;
    lb_numdiff: TLabel;
    MenuHoming: TPopupMenu;
    Machine1: TMenuItem;
    Fixture1: TMenuItem;
    HomeX1: TMenuItem;
    HomeY1: TMenuItem;
    Home1: TMenuItem;
    HomeXY1: TMenuItem;
    HomeXYZ1: TMenuItem;
    HomeX2: TMenuItem;
    HomeY2: TMenuItem;
    HomeZ1: TMenuItem;
    HomeXY2: TMenuItem;
    HomeXYZ2: TMenuItem;
    lb_homing: TLabel;
    btn_pause: TButton;
    btn_stop: TButton;
    btn_resume: TButton;
    Label16: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BtnComportClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_fileClick(Sender: TObject);
    procedure btn_runClick(Sender: TObject);
    procedure btn_showpathClick(Sender: TObject);
    procedure btn_hidepathClick(Sender: TObject);
    procedure btn_i2cClick(Sender: TObject);
    procedure btn_sg4Click(Sender: TObject);
    procedure btn_xplusClick(Sender: TObject);
    procedure btn_submit1Click(Sender: TObject);
    procedure cb_unitChange(Sender: TObject);
    procedure cb_vunitChange(Sender: TObject);
    procedure HomeX1Click(Sender: TObject);
    procedure cb_stepKeyPress(Sender: TObject; var Key: Char);
    procedure btn_stopClick(Sender: TObject);
    procedure btn_resumeClick(Sender: TObject);
    procedure btn_pauseClick(Sender: TObject);
  private
    { Private declarations }
    procedure EngineThreadEnde(Sender: TObject);
  public
    { Public declarations }
    vcl_run_gcode : byte;
    procedure setstatus(stxt : String);
    function mSecToTime(AmSec : DWORD) : String;
    procedure SetProgress(fvalue : Single);
    procedure SetElapsedTime(dwmSec : DWORD);
    procedure Disable_Controls(dis : boolean);
    procedure RunCtls(state : Byte);

    function Start_EngineThread : Boolean;
    procedure Stop_EngineThread;

    procedure InitManualStepRange(AUnitsPerStep : Double; ALengthUnit : Boolean);

    procedure VelocityUnitChanged;
    procedure LengthUnitChanged;

    procedure StoreSettings;
    procedure RestoreSettings;
    function ConvertGCodeToSG4Code : Boolean;
  end;

var
  fmmain : Tfmmain;
  hcomm : THandle;
  EngineThread : TEngineThread;

  gcode_line : TGCodeLine;
  gcodeSG4 : TGCodeConverter;
  alist    : TStringList;
  settings : TSettings;

implementation

uses UnitI2C, UnitCmds;

{$R *.DFM}

{ TForm1 }

procedure Tfmmain.setstatus(stxt: String);
begin
  StatusBar1.Panels[0].Text := stxt;
end;

procedure Tfmmain.FormCreate(Sender: TObject);
begin
  hcomm := INVALID_HANDLE_VALUE;
  cb_baud.ItemIndex := 12;
  cb_step.ItemIndex := 0;
  cb_unit.ItemIndex := 1;
  cb_unit.Tag := 1;
  cb_vunit.ItemIndex := 0;
  cb_vunit.Tag := 0;
  vcl_run_gcode := 0;

  gcode_line := TGCodeLine.Create;
  gcodeSG4 := TGCodeConverter.Create;
  alist := TStringList.Create;
  RestoreSettings;
  InitManualStepRange(gcodeSG4.Params.UnitsPerStep,gcodeSG4.Params.LengthUnit);
end;

procedure Tfmmain.BtnComportClick(Sender: TObject);
var comnr : Integer;
    dwbaud : DWORD;
    dwerr : DWORD;
begin
  comnr := StrToIntDef(ed_comnr.Text,1);
  dwbaud := StrToIntDef(cb_baud.Items[cb_baud.Itemindex],115200);
  if ComPortConnected(hcomm) then
  begin
    setstatus('Close ComPort:..'+ cx_GetErrorString(CloseComPort(hcomm)));
  end else
  begin
    setstatus('Open ComPort:..'+ cx_GetErrorString(OpenComPort(hcomm,comnr)));
  end;

  if ComPortConnected(hcomm) then
  begin
    BtnComport.Caption := 'COM'+IntToStr(comnr);
    dwerr := SetBaud(hcomm,dwbaud);
    if dwerr = RET_OK then lbbaud.caption := IntToStr(dwbaud)
    else begin
      lbbaud.caption := '-----';
      setstatus('Set Baud:..'+ cx_GetErrorString(dwerr));
      BtnComport.Caption := 'COM?';
      CloseComPort(hcomm);
      exit;
    end;

    dwerr := SetTimeOuts(hcomm,3000,3000); //3 seconds timeout for rx and tx
    if dwerr <> RET_OK then
    begin
      setstatus('Set TimeOuts:..'+ cx_GetErrorString(dwerr));
      BtnComport.Caption := 'COM?';
      CloseComPort(hcomm);
      exit;
    end;

    if not Start_EngineThread then
    begin
      BtnComport.Caption := 'COM?';
      CloseComPort(hcomm);
    end;
  end else
  begin
    Stop_EngineThread;
    BtnComport.Caption := 'COM?';
  end;                
end;

procedure Tfmmain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseComPort(hcomm);
  gcode_line.Free;
  gcodeSG4.Free;
  alist.Free;
end;

procedure Tfmmain.Disable_Controls(dis: boolean);
begin
  btn_file.Enabled := not dis;
  btn_xplus.Enabled := not dis;
  btn_xminus.Enabled := not dis;
  btn_yplus.Enabled := not dis;
  btn_yminus.Enabled := not dis;
  btn_zplus.Enabled := not dis;
  btn_zminus.Enabled := not dis;
  btn_i2c.Enabled := not dis;
  btn_sg4.Enabled := not dis;
  btn_submit1.Enabled := not dis;
  cb_unit.Enabled := not dis;
  lb_homing.Enabled := not dis;
end;

procedure Tfmmain.RunCtls(state: Byte);
begin
  btn_run.Enabled := (state = 0);
  btn_stop.Enabled := (state <> 0);
  btn_pause.Enabled := (state = 1);
  btn_resume.Enabled := (state = 2);
end;

procedure Tfmmain.btn_fileClick(Sender: TObject);
begin
  lb_gcode.Clear;
  lb_sg4code.Clear;
  if od_gcode.Execute then
    lb_gcode.Items.LoadFromFile(od_gcode.filename);
end;

function Tfmmain.ConvertGCodeToSG4Code : Boolean;
var i : integer;
    dwerr : DWORD;
begin
  lb_sg4code.Clear;
  alist.Clear;
  if lb_gcode.Items.Count > 0 then
  begin
    for i := 0 to lb_gcode.Items.Count - 1 do
    begin
      dwerr := gcodeSG4.GetSG4Code(lb_gcode.Items.Strings[i],i);
      case dwerr of
      RET_OK : alist.AddStrings(gcodeSG4.SG4Cmds);
      ERR_GCODELIST_EMPTY,
      ERR_LINE_EMPTY:;
      else begin
             lb_gcode.ItemIndex := i;
             Showmessage('ERROR: '+cx_GetErrorString(dwerr)+' (Line #'+IntToStr(i+1)+')');
             alist.Clear;
             break;
           end;
      end;
    end;
  end;
  Result := (alist.Count > 0);
  if Result then
    lb_sg4code.Items.AddStrings(alist);
end;

procedure Tfmmain.SetElapsedTime(dwmSec: DWORD);
begin
  StatusBar1.Panels[4].Text := mSecToTime(dwmSec);
end;

procedure Tfmmain.SetProgress(fvalue: Single);
begin
  StatusBar1.Panels[2].Text := Format('%f',[fvalue])+'%';
end;

function Tfmmain.mSecToTime(AmSec: DWORD): String;
var ZH, ZM, ZS, ZmS: DWORD;
begin
  ZH := AmSec div 3600000;
  ZM := (AmSec div 60000) - (ZH * 60);
  ZS := (AmSec DIV 1000) - ((ZH * 3600) + (ZM * 60));
  ZmS := AmSec - ((ZH * 3600000) + (ZM * 60000) + (ZS * 1000));
  Result := Format('%.2d:%.2d:%.2d.%.3d',[ZH,ZM,ZS,ZmS]);
end;

procedure Tfmmain.btn_showpathClick(Sender: TObject);
begin
  showpath;
end;

procedure Tfmmain.btn_hidepathClick(Sender: TObject);
begin
  hidepath;
end;

procedure Tfmmain.btn_i2cClick(Sender: TObject);
begin
  fmI2C.ShowModal;
end;

procedure Tfmmain.btn_sg4Click(Sender: TObject);
begin
  fmSG4.ShowModal;
end;

procedure Tfmmain.cb_stepKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key = '.') OR (Key = ',')) and  (Key <> DecimalSeparator) then
    Key := DecimalSeparator;
end;

procedure Tfmmain.btn_xplusClick(Sender: TObject);
var steps : integer;
    units : double;
begin
  units := strtofloat(cb_step.Text);
  steps := gcodeSG4.LengthToSteps(units);
  case (Sender As TButton).Tag of
  0: setstatus('relative X+:..'+ cx_GetErrorString(cx_set_position(hcomm,'s50:X'+IntToStr(steps),true)));
  1: setstatus('relative Y+:..'+ cx_GetErrorString(cx_set_position(hcomm,'s50:Y'+IntToStr(steps),true)));
  2: setstatus('relative Z+:..'+ cx_GetErrorString(cx_set_position(hcomm,'s50:Z'+IntToStr(steps),true)));
  3: setstatus('relative X-:..'+ cx_GetErrorString(cx_set_position(hcomm,'s50:X'+IntToStr(-steps),true)));
  4: setstatus('relative Y-:..'+ cx_GetErrorString(cx_set_position(hcomm,'s50:Y'+IntToStr(-steps),true)));
  5: setstatus('relative Z-:..'+ cx_GetErrorString(cx_set_position(hcomm,'s50:Z'+IntToStr(-steps),true)));
  end;
end;

procedure Tfmmain.btn_runClick(Sender: TObject);
begin
  clearpath;
  if ComPortConnected(hcomm) then
  begin
    vcl_run_gcode := Byte(ConvertGCodeToSG4Code);
  end;
end;

procedure Tfmmain.btn_stopClick(Sender: TObject);
begin
  vcl_run_gcode := 0;
end;

procedure Tfmmain.btn_resumeClick(Sender: TObject);
begin
  vcl_run_gcode := 3;
end;

procedure Tfmmain.btn_pauseClick(Sender: TObject);
begin
  vcl_run_gcode := 2;
end;

procedure Tfmmain.EngineThreadEnde(Sender: TObject);
begin
  FreeAndNil(EngineThread);
  if ComPortConnected(hcomm) then BtnComportClick(Sender);
  Disable_Controls(false);
end;

function Tfmmain.Start_EngineThread : Boolean;
begin
  Result := false;
  if EngineThread = nil then
  begin
    if (cx_hardstop(hcomm) <> RET_OK) OR
       (cx_set_vmax(hcomm,settings.Vmax,false) <> RET_OK) OR
       (cx_set_vmin(hcomm,settings.Vmin,false) <> RET_OK) OR
       (cx_set_accel(hcomm,settings.Accel,false) <> RET_OK) OR
       (cx_set_decel(hcomm,settings.Decel,false) <> RET_OK) OR
       (cx_fiforeset(hcomm) <> RET_OK) then
    begin
      setstatus('Initialzing SG4 failed!');
      exit;
    end;

    EngineThread := TEngineThread.Create(true);
    EngineThread.cmd_stop := false;
    EngineThread.gcode_run := 0;
    EngineThread.com_handle := hcomm;
    EngineThread.OnTerminate := EngineThreadEnde;
    EngineThread.Resume;
    Result := true;
  end;
end;

procedure Tfmmain.Stop_EngineThread;
begin
  if EngineThread <> nil then
  begin
    EngineThread.cmd_stop := true;
    if not EngineThread.Terminated then EngineThread.Terminate;
  end;
end;

{ TEngineThread }

procedure TEngineThread.DisableControls;
begin
  fmMain.Disable_Controls(gcode_run <> 0);
  fmMain.RunCtls(gcode_run);
  fmMain.vcl_run_gcode := gcode_run;
end;

procedure TEngineThread.Execute;
var dwerr : DWORD;
    stopflag1, stopflag2, pauseflag : Boolean;
begin
  idx_sg4 := 0;
  cnc_code := '';

  repeat
    if gcode_run = 1 then
    begin
      Synchronize(disableControls);

      idx_sg4 := 0;
      cnc_code := '';
      Synchronize(get_cnc_code);
      if not ((cnc_code = '') or (idx_sg4 = -1) or (cx_fiforeset(com_handle) <> RET_OK)) then
      begin
        TimeTicks := GetTickCount;
        stopflag1 := false;
        pauseflag := false;
        repeat
          case gcode_run of
          0: begin
               stopflag1 := (cx_softstop(hcomm) <> RET_OK);
             end;
          1: begin
               stopflag1 := move_next;
             end;
          2: begin
               if not pauseflag then
               begin
                 stopflag1 := (cx_softstop(hcomm) <> RET_OK);
                 Synchronize(disableControls);
                 pauseflag := true;
               end;
             end;
          3: begin
               stopflag1 := (cx_continue(hcomm) <> RET_OK);
               gcode_run := 1;
               Synchronize(disableControls);
               pauseflag := false;
             end;
          end;
          stopflag2 := update_params;
        until (gcode_run = 0) or cmd_stop OR Terminated OR stopflag1 OR stopflag2;
      end;

      if cx_get_acts(com_handle,AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG,
                     AX,AY,AZ,AU,ANUM,AVACT) = RET_OK then
      begin
        Synchronize(display_status);
        if ARUN <> ST_STOPPED then
         cx_softstop(hcomm);
      end;

      gcode_run := 0;
      Synchronize(disableControls);

      if cmd_stop OR Terminated then exit;
    end;


    dwerr := cx_get_acts(com_handle,AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG,
                         AX,AY,AZ,AU,ANUM,AVACT);
    if dwerr = RET_OK then
      Synchronize(display_status);
  until cmd_stop OR Terminated OR (dwerr <> RET_OK);
end;

procedure TEngineThread.get_cnc_code;
begin
  if (fmmain.lb_sg4code.items.count = 0) OR
     (idx_sg4 > fmmain.lb_sg4code.items.count -1) then
  begin
    idx_sg4 := -1;
    cnc_code := '';
    exit;
  end;
  fmmain.lb_sg4code.ItemIndex := idx_sg4;
  if fmmain.lb_sg4code.Items.Objects[idx_sg4] <> nil then
    last_buffered_line_num := DWORD(fmmain.lb_sg4code.Items.Objects[idx_sg4]);
  cnc_code := fmmain.lb_sg4code.Items[fmmain.lb_sg4code.ItemIndex];
end;

function TEngineThread.move_next: boolean;
begin
  Result := false;
  if (idx_sg4 >= 0) and (cnc_code <> '') then
  begin
    case cx_move_it(com_handle,cnc_code) of
    RET_OK : begin
               inc(idx_sg4);
               Synchronize(get_cnc_code);
             end;
    ERR_FIFO_FULL :
             begin

             end;
    else     begin
               Result := true;
             end;
    end;
  end;
end;

function TEngineThread.update_params: boolean;
begin
  if cx_get_acts(com_handle,AERR,AFIFO,ADELAY,ARUN,ASW,AFLAG,
                       AX,AY,AZ,AU,ANUM,AVACT) = RET_OK then
  begin
    Result := (AERR > 0) or
              //(AFIFO = 0) or
              ((ANUM = gcode_lines_count -1) and (ARUN = ST_STOPPED));
    Synchronize(display_status);
  end else Result := true;
end;

procedure TEngineThread.display_status;
begin
  with fmMain do
  begin
    lb_cax.caption := Format('%.4f',[gcodeSG4.StepsToLength(AX)]);
    lb_cay.caption := Format('%.4f',[gcodeSG4.StepsToLength(AY)]);
    lb_caz.caption := Format('%.4f',[gcodeSG4.StepsToLength(AZ)]);
    lb_fax.caption := Format('%.4f',[gcodeSG4.StepsToLength(AX) - gcodeSG4.params.XOffSet]);
    lb_fay.caption := Format('%.4f',[gcodeSG4.StepsToLength(AY) - gcodeSG4.params.YOffSet]);
    lb_faz.caption := Format('%.4f',[gcodeSG4.StepsToLength(AZ) - gcodeSG4.params.ZOffSet]);

    lb_cav.caption := Format('%f',[gcodeSG4.StepsPerSecondToVelocity(AVACT)]);

    lb_cav.caption := fmmain.lb_cav.caption;
    lb_cnum.caption := IntToStr(ANUM);

    cb_rx.Checked := ((ASW and $01) = $01);
    cb_ry.Checked := ((ASW and $02) = $02);
    cb_rz.Checked := ((ASW and $04) = $04);
    cb_ru.Checked := ((ASW and $08) = $08);

    cb_lx.Checked := ((ASW and $10) = $10);
    cb_ly.Checked := ((ASW and $20) = $20);
    cb_lz.Checked := ((ASW and $40) = $40);
    cb_lu.Checked := ((ASW and $80) = $80);

    cb_frx.Checked := ((AFLAG and $01) = $01);
    cb_fry.Checked := ((AFLAG and $02) = $02);
    cb_frz.Checked := ((AFLAG and $04) = $04);
    cb_fru.Checked := ((AFLAG and $08) = $08);

    cb_flx.Checked := ((AFLAG and $10) = $10);
    cb_fly.Checked := ((AFLAG and $20) = $20);
    cb_flz.Checked := ((AFLAG and $40) = $40);
    cb_flu.Checked := ((AFLAG and $80) = $80);

    lb_runstate.caption := get_runstate(ARUN);

    cb_fifoenabled.checked := ((AFIFO and $01) = $01);
    cb_error.checked := ((AERR and $01) = $01);
    cb_DELAY.checked := ((ADELAY and $01) = $01);
    if gcode_run <> 0 then
    begin
      putxyz(gcodeSG4.StepsToLength(AX),gcodeSG4.StepsToLength(AY),gcodeSG4.StepsToLength(AZ));
      lb_gcode.ItemIndex := ANUM;
      lb_cbufnum.caption := IntToStr(last_buffered_line_num);
      lb_numdiff.caption := IntToStr(last_buffered_line_num - ANUM);
      gcode_lines_count := lb_gcode.items.count;
      SetProgress(100*ANUM/(gcode_lines_count-1));
      SetElapsedTime(GetTickCount-TimeTicks);
    end;
    gcode_run := vcl_run_gcode;
  end;
  fmmain.update;
end;

function TEngineThread.get_runstate(AState: Byte): String;
begin
  Result := '';
  case AState of
    ST_STOPPED     : Result := 'STOPPED';
    ST_ACCEL       : Result := 'ACCELERATION';
    ST_RUN         : Result := 'CONSTANT VELOCITY';
    ST_DECEL       : Result := 'DECELERATION';
    ST_RUN_TO_STOP : Result := 'RUN_TO_STOP';
    ST_SOFT_STOP   : Result := 'SOFT_STOPPING';
    ST_HARD_STOP   : Result := 'HARD_STOPPING';
    ST_STOPPING    : Result := 'STOPPING';
  end;
end;

procedure Tfmmain.btn_submit1Click(Sender: TObject);
var fmt : String;
begin
  gcodeSG4.Params.LengthUnit := (cb_unit.ItemIndex = 0);
  gcodeSG4.Params.UnitsPerStep := StrToFloat(ed_unitperstep.Text);

  InitManualStepRange(gcodeSG4.Params.UnitsPerStep,gcodeSG4.Params.LengthUnit);

  gcodeSG4.Params.VminPercentOfVmax := StrToIntDef(ed_vminpervmax.Text,50);
  ed_vminpervmax.Text := IntToStr(gcodeSG4.Params.VminPercentOfVmax);
  gcodeSG4.Params.AccelDecelTime := StrToIntDef(ed_acceltime.Text,500);
  ed_acceltime.Text := IntToStr(gcodeSG4.Params.AccelDecelTime);

  case cb_vunit.itemindex of
  0 : begin
        gcodeSG4.Params.VmaxUpperLimitSteps := Round(StrToFloat(ed_vmax_ul.Text));
        gcodeSG4.Params.VminUpperLimitSteps := Round(StrToFloat(ed_vmin_ul.Text));
        gcodeSG4.Params.VmaxLowerLimitSteps := Round(StrToFloat(ed_vmax_ll.Text));
        gcodeSG4.Params.VminLowerLimitSteps := Round(StrToFloat(ed_vmin_ll.Text));
        gcodeSG4.Params.VmaxSteps := Round(StrToFloat(ed_vmax.Text));
        if gcodeSG4.Params.VminPercentOfVmax = 0 then
          gcodeSG4.Params.VminSteps := Round(StrToFloat(ed_vmin.Text));
        if gcodeSG4.Params.AccelDecelTime = 0 then
        begin
          gcodeSG4.Params.AccelSteps := Round(StrToFloat(ed_accel.Text));
          gcodeSG4.Params.DecelSteps := Round(StrToFloat(ed_decel.Text));
        end;
        ed_vmax_ul.Text := IntToStr(gcodeSG4.Params.VmaxUpperLimitSteps);
        ed_vmin_ul.Text := IntToStr(gcodeSG4.Params.VminUpperLimitSteps);
        ed_vmax_ll.Text := IntToStr(gcodeSG4.Params.VmaxLowerLimitSteps);
        ed_vmin_ll.Text := IntToStr(gcodeSG4.Params.VminLowerLimitSteps);
        ed_vmax.Text := IntToStr(gcodeSG4.Params.VmaxSteps);
        ed_vmin.Text := IntToStr(gcodeSG4.Params.VminSteps);
        ed_accel.Text := IntToStr(gcodeSG4.Params.AccelSteps);
        ed_decel.Text := IntToStr(gcodeSG4.Params.DecelSteps);
      end;
  1 : begin
        gcodeSG4.Params.VmaxUpperLimitUnits := StrToFloat(ed_vmax_ul.Text);
        gcodeSG4.Params.VminUpperLimitUnits := StrToFloat(ed_vmin_ul.Text);
        gcodeSG4.Params.VmaxLowerLimitUnits := StrToFloat(ed_vmax_ll.Text);
        gcodeSG4.Params.VminLowerLimitUnits := StrToFloat(ed_vmin_ll.Text);
        gcodeSG4.Params.VmaxUnits := StrToFloat(ed_vmax.Text);
        if gcodeSG4.Params.VminPercentOfVmax = 0 then
          gcodeSG4.Params.VminUnits := StrToFloat(ed_vmin.Text);
        if gcodeSG4.Params.AccelDecelTime = 0 then
        begin
          gcodeSG4.Params.AccelUnits := StrToFloat(ed_accel.Text);
          gcodeSG4.Params.DecelUnits := StrToFloat(ed_decel.Text);
        end;

        if cb_unit.ItemIndex = 0 then fmt := '%.4f'
        else fmt := '%.2f';

        ed_vmax_ul.Text := Format(fmt,[gcodeSG4.Params.VmaxUpperLimitUnits]);
        ed_vmin_ul.Text := Format(fmt,[gcodeSG4.Params.VminUpperLimitUnits]);
        ed_vmax_ll.Text := Format(fmt,[gcodeSG4.Params.VmaxLowerLimitUnits]);
        ed_vmin_ll.Text := Format(fmt,[gcodeSG4.Params.VminLowerLimitUnits]);
        ed_vmax.Text := Format(fmt,[gcodeSG4.Params.VmaxUnits]);
        ed_vmin.Text := Format(fmt,[gcodeSG4.Params.VminUnits]);
        ed_accel.Text := Format(fmt,[gcodeSG4.Params.AccelUnits]);
        ed_decel.Text := Format(fmt,[gcodeSG4.Params.DecelUnits]);
      end;
  end;
  settings.Vmax := gcodeSG4.Params.VmaxSteps;
  settings.Vmin := gcodeSG4.Params.VminSteps;
  settings.Accel := gcodeSG4.Params.AccelSteps;
  settings.Decel := gcodeSG4.Params.DecelSteps;

  StoreSettings;
end;

procedure Tfmmain.InitManualStepRange(AUnitsPerStep : Double; ALengthUnit : Boolean);
var fmt : string;
begin
  if ALengthUnit then fmt := '%.10f'
  else fmt := '%.6f';
  cb_step.Clear;
  cb_step.Items.Add(Format(fmt,[AUnitsPerStep]));
  cb_step.Items.Add(Format(fmt,[AUnitsPerStep * 5]));
  cb_step.Items.Add(Format(fmt,[AUnitsPerStep * 10]));
  cb_step.Items.Add(Format(fmt,[AUnitsPerStep * 50]));
  cb_step.Items.Add(Format(fmt,[AUnitsPerStep * 100]));
  cb_step.Items.Add(Format(fmt,[AUnitsPerStep * 500]));
  cb_step.Items.Add(Format(fmt,[AUnitsPerStep * 1000]));
  cb_step.ItemIndex := 0;
end;

procedure Tfmmain.LengthUnitChanged;
var tmp : double;
    old_idx : integer;
begin
  if cb_unit.Tag = cb_unit.ItemIndex then exit;
  cb_unit.Tag := cb_unit.ItemIndex;

  old_idx := cb_vunit.ItemIndex;
  if cb_vunit.ItemIndex = 1 then
  begin
    cb_vunit.ItemIndex := 0;
    VelocityUnitChanged;
  end;

  tmp := StrToFloat(ed_unitperstep.Text);

  case cb_unit.ItemIndex of
  0: begin
       tmp := gcodeSG4.MillimeterToInch(tmp);
       ed_unitperstep.Text := Format('%.10f',[tmp]);
     end;
  1: begin
       tmp := gcodeSG4.InchToMillimeter(tmp);
       ed_unitperstep.Text := Format('%.6f',[tmp]);
     end;
  end;

  if old_idx = 1 then
  begin
    cb_vunit.ItemIndex := 1;
    VelocityUnitChanged;
  end;
end;

procedure Tfmmain.VelocityUnitChanged;
var units_per_step : Double;
    fmt : String;
begin
  if cb_vunit.Tag = cb_vunit.ItemIndex then exit;
  cb_vunit.Tag := cb_vunit.ItemIndex;

  units_per_step := StrToFloat(ed_unitperstep.Text);
  case cb_vunit.ItemIndex of
  0: begin
       ed_vmax_ul.Text := IntToStr(gcodeSG4.VelocityToStepsPerSecond(StrToFloat(ed_vmax_ul.Text),units_per_step));
       ed_vmin_ul.Text := IntToStr(gcodeSG4.VelocityToStepsPerSecond(StrToFloat(ed_vmin_ul.Text),units_per_step));
       ed_vmax_ll.Text := IntToStr(gcodeSG4.VelocityToStepsPerSecond(StrToFloat(ed_vmax_ll.Text),units_per_step));
       ed_vmin_ll.Text := IntToStr(gcodeSG4.VelocityToStepsPerSecond(StrToFloat(ed_vmin_ll.Text),units_per_step));
       ed_vmax.Text := IntToStr(gcodeSG4.VelocityToStepsPerSecond(StrToFloat(ed_vmax.Text),units_per_step));
       ed_vmin.Text := IntToStr(gcodeSG4.VelocityToStepsPerSecond(StrToFloat(ed_vmin.Text),units_per_step));
       ed_accel.Text := IntToStr(gcodeSG4.AccelToStepsPerSecSec(StrToFloat(ed_accel.Text),units_per_step));
       ed_decel.Text := IntToStr(gcodeSG4.AccelToStepsPerSecSec(StrToFloat(ed_decel.Text),units_per_step));
     end;
  1: begin
       if cb_unit.ItemIndex = 0 then fmt := '%.4f'
       else fmt := '%.2f';
       ed_vmax_ul.Text := Format(fmt,[gcodeSG4.StepsPerSecondToVelocity(Round(StrToFloat(ed_vmax_ul.Text)),units_per_step)]);
       ed_vmin_ul.Text := Format(fmt,[gcodeSG4.StepsPerSecondToVelocity(Round(StrToFloat(ed_vmin_ul.Text)),units_per_step)]);
       ed_vmax_ll.Text := Format(fmt,[gcodeSG4.StepsPerSecondToVelocity(Round(StrToFloat(ed_vmax_ll.Text)),units_per_step)]);
       ed_vmin_ll.Text := Format(fmt,[gcodeSG4.StepsPerSecondToVelocity(Round(StrToFloat(ed_vmin_ll.Text)),units_per_step)]);
       ed_vmax.Text := Format(fmt,[gcodeSG4.StepsPerSecondToVelocity(Round(StrToFloat(ed_vmax.Text)),units_per_step)]);
       ed_vmin.Text := Format(fmt,[gcodeSG4.StepsPerSecondToVelocity(Round(StrToFloat(ed_vmin.Text)),units_per_step)]);
       ed_accel.Text := Format(fmt,[gcodeSG4.StepsPerSecSecToAccel(Round(StrToFloat(ed_accel.Text)),units_per_step)]);
       ed_decel.Text := Format(fmt,[gcodeSG4.StepsPerSecSecToAccel(Round(StrToFloat(ed_decel.Text)),units_per_step)]);
     end;
  end;
end;

procedure Tfmmain.cb_unitChange(Sender: TObject);
begin
  LengthUnitChanged;
end;

procedure Tfmmain.cb_vunitChange(Sender: TObject);
begin
  VelocityUnitChanged;
end;

procedure Tfmmain.StoreSettings;
var ini : TIniFile;
begin
  ini := TIniFile.Create(ExtractFilePath(ParamStr(0))+'sg4settings.ini');
  ini.WriteInteger('Settings','LengthUnit',Byte(gcodeSG4.Params.LengthUnit));
  ini.WriteFloat('Settings','UnitsPerStep',gcodeSG4.Params.UnitsPerStep);

  ini.WriteInteger('Settings','VelUnit',cb_vunit.ItemIndex);
  ini.WriteInteger('Settings','VminPercentOfVmax',gcodeSG4.Params.VminPercentOfVmax);
  ini.WriteInteger('Settings','AccelDecelTime',gcodeSG4.Params.AccelDecelTime);

  ini.WriteInteger('Settings','VmaxUL',gcodeSG4.Params.VmaxUpperLimitSteps);
  ini.WriteInteger('Settings','VminUL',gcodeSG4.Params.VminUpperLimitSteps);
  ini.WriteInteger('Settings','VmaxLL',gcodeSG4.Params.VmaxLowerLimitSteps);
  ini.WriteInteger('Settings','VminLL',gcodeSG4.Params.VminLowerLimitSteps);

  ini.WriteInteger('Settings','Vmax',settings.Vmax);
  ini.WriteInteger('Settings','Vmin',settings.Vmin);
  ini.WriteInteger('Settings','Accel',settings.Accel);
  ini.WriteInteger('Settings','Decel',settings.Decel);

  ini.free;
end;

procedure Tfmmain.RestoreSettings;
var ini : TIniFile;
begin
  ini := TIniFile.Create(ExtractFilePath(ParamStr(0))+'sg4settings.ini');

  cb_unit.ItemIndex := ini.ReadInteger('Settings','LengthUnit',1);
  cb_unit.Tag := cb_unit.ItemIndex;
  gcodeSG4.Params.LengthUnit := Bool(cb_unit.ItemIndex);

  gcodeSG4.Params.UnitsPerStep := ini.ReadFloat('Settings','UnitsPerStep',1);

  settings.VelUnit := ini.ReadInteger('Settings','VelUnit',0);
  cb_vunit.ItemIndex := 0; {steps/s}
  cb_vunit.Tag := 0;

  settings.Vmax := ini.ReadInteger('Settings','Vmax',5000);
  gcodeSG4.Params.VmaxSteps := settings.Vmax;
  settings.Vmin := ini.ReadInteger('Settings','Vmin',2500);
  gcodeSG4.Params.VminSteps := settings.Vmin;
  settings.Accel := ini.ReadInteger('Settings','Accel',10000);
  gcodeSG4.Params.AccelSteps := settings.Accel;
  settings.Decel := ini.ReadInteger('Settings','Decel',10000);
  gcodeSG4.Params.DecelSteps := settings.Decel;

  gcodeSG4.Params.VminPercentOfVmax := ini.ReadInteger('Settings','VminPercentOfVmax',50);
  gcodeSG4.Params.AccelDecelTime := ini.ReadInteger('Settings','AccelDecelTime',100);
  gcodeSG4.Params.VmaxUpperLimitSteps := ini.ReadInteger('Settings','VmaxUL',100000);
  gcodeSG4.Params.VminUpperLimitSteps := ini.ReadInteger('Settings','VminUL',100000);
  gcodeSG4.Params.VmaxLowerLimitSteps := ini.ReadInteger('Settings','VmaxLL',100);
  gcodeSG4.Params.VminLowerLimitSteps := ini.ReadInteger('Settings','VminLL',100);

  ini.free;

  ed_vminpervmax.Text := IntToStr(gcodeSG4.Params.VminPercentOfVmax);
  ed_acceltime.Text := IntToStr(gcodeSG4.Params.AccelDecelTime);
  ed_vmax_ul.Text := IntToStr(gcodeSG4.Params.VmaxUpperLimitSteps);
  ed_vmin_ul.Text := IntToStr(gcodeSG4.Params.VminUpperLimitSteps);
  ed_vmax_ll.Text := IntToStr(gcodeSG4.Params.VmaxLowerLimitSteps);
  ed_vmin_ll.Text := IntToStr(gcodeSG4.Params.VminLowerLimitSteps);
  ed_vmax.Text := IntToStr(gcodeSG4.Params.VmaxSteps);
  ed_vmin.Text := IntToStr(gcodeSG4.Params.VminSteps);
  ed_accel.Text := IntToStr(gcodeSG4.Params.AccelSteps);
  ed_decel.Text := IntToStr(gcodeSG4.Params.DecelSteps);
  cb_vunit.ItemIndex := settings.VelUnit;
  VelocityUnitChanged;
end;

procedure Tfmmain.HomeX1Click(Sender: TObject);
var AX, AY, AZ, AU : Integer;
    dwerr : DWORD;
begin
  dwerr := cx_get_actpos(hcomm,AX,AY,AZ,AU);
  if dwerr <> RET_OK then
  begin
    setstatus('Get actual position:..'+ cx_GetErrorString(dwerr));
    Exit;
  end;

  case (Sender As TMenuItem).Tag of
  0 : dwerr := cx_set_act_position(hcomm,'X0');
  1 : dwerr := cx_set_act_position(hcomm,'Y0');
  2 : dwerr := cx_set_act_position(hcomm,'Z0');
  3 : dwerr := cx_set_act_position(hcomm,'X0 Y0');
  4 : dwerr := cx_set_act_position(hcomm,'X0 Y0 Z0');
  5 : gcodeSG4.Params.XOffSetSteps := AX;
  6 : gcodeSG4.Params.YOffSetSteps := AY;
  7 : gcodeSG4.Params.ZOffSetSteps := AZ;
  8 : begin
        gcodeSG4.Params.XOffSetSteps := AX;
        gcodeSG4.Params.YOffSetSteps := AY;
      end;
  9 : begin
        gcodeSG4.Params.XOffSetSteps := AX;
        gcodeSG4.Params.YOffSetSteps := AY;
        gcodeSG4.Params.ZOffSetSteps := AZ;
      end;
  end;

  setstatus('Set Home:..'+ cx_GetErrorString(dwerr));
end;

end.
