unit udef;

interface

const   INCH_TO_MM    = 25.4;
        MM_TO_INCH    = 1 / INCH_TO_MM;

        G_0     = 0;
        G_1     = 10;
        G_2     = 20;
        G_3     = 30;
        G_4     = 40;
        G_10    = 100;
        G_17    = 170;
        G_18    = 180;
        G_19    = 190;
        G_20    = 200;
        G_21    = 210;
        G_28    = 280;
        G_30    = 300;
        G_38_2  = 382;
        G_40    = 400;
        G_41    = 410;
        G_42    = 420;
        G_43    = 430;
        G_49    = 490;
        G_53    = 530;
        G_54    = 540;
        G_55    = 550;
        G_56    = 560;
        G_57    = 570;
        G_58    = 580;
        G_59    = 590;
        G_59_1  = 591;
        G_59_2  = 592;
        G_59_3  = 593;
        G_61    = 610;
        G_61_1  = 611;
        G_64    = 640;
        G_80    = 800;
        G_81    = 810;
        G_82    = 820;
        G_83    = 830;
        G_84    = 840;
        G_85    = 850;
        G_86    = 860;
        G_87    = 870;
        G_88    = 880;
        G_89    = 890;
        G_90    = 900;
        G_90_1  = 901;
        G_91    = 910;
        G_91_1  = 911;
        G_92    = 920;
        G_92_1  = 921;
        G_92_2  = 922;
        G_92_3  = 923;
        G_93    = 930;
        G_94    = 940;
        G_98    = 980;
        G_99    = 990;

        M_0     = 0;
        M_1     = 10;
        M_2     = 20;
        M_3     = 30;
        M_4     = 40;
        M_5     = 50;
        M_6     = 60;
        M_7     = 70;
        M_8     = 80;
        M_9     = 90;
        M_30    = 300;
        M_48    = 480;
        M_49    = 490;
        M_60    = 600;

        //non-modal G codes
        cGroup_00 : array[0..8] of integer = (G_4,G_10,G_28,G_30,G_53,G_92,G_92_1,G_92_2,G_92_3);
        //motion
        cGroup_G1 : array[0..14] of integer = (G_0,G_1,G_2,G_3,G_38_2,G_80,G_81,G_82,G_83,G_84,G_85,G_86,G_87,G_88,G_89);
        //plane selection
        cGroup_G2 : array[0..2] of integer = (G_17,G_18,G_19);
        //distance mode
        cGroup_G3 : array[0..1] of integer = (G_90,G_91);
        //arc distance mode
        cGroup_G3_1 : array[0..1] of integer = (G_90_1,G_91_1);
        //feed rate mode
        cGroup_G5 : array[0..1] of integer = (G_93,G_94);
        //units
        cGroup_G6 : array[0..1] of integer = (G_20,G_21);
        //cutter radius compensation
        cGroup_G7 : array[0..2] of integer = (G_40,G_41,G_42);
        //tool length offset
        cGroup_G8 : array[0..1] of integer = (G_43,G_49);
        //return mode in canned cycles
        cGroup_G10 : array[0..1] of integer = (G_98,G_99);
        //coordinate system selection
        cGroup_G12 : array[0..8] of integer = (G_54,G_55,G_56,G_57,G_58,G_59,G_59_1,G_59_2,G_59_3);
        //path control mode
        cGroup_G13 : array[0..2] of integer = (G_61,G_61_1,G_64);

        //stopping
        cGroup_M4 : array[0..4] of integer = (M_0,M_1,M_2,M_30,M_60);
        //tool change
        cGroup_M6 : array[0..0] of integer = (M_6);
        //spindle turning
        cGroup_M7 : array[0..2] of integer = (M_3,M_4,M_5);
        //coolant (special case: M7 and M8 may be active at the same time)
        cGroup_M8 : array[0..2] of integer = (M_7,M_8,M_9);
        //enable/disable feed and speed override switches
        cGroup_M9 : array[0..1] of integer = (M_48,M_49);

        cParams : array[0..16] of Char = ('X','Y','Z','I','J','K','R','Q','L','F','S','T','D','H','N','O','P');
        
        DELETE_GCODE = TRUE;
        NO_DELETE_GCODE = FALSE;

implementation

end.
